"use strict";
define(["happtype"] ,function(happtype){
    /**
     *  控制桥执行代码！目前提供给各子js使用，ios和android分开实现自己的bridgeIOC
     */
    function bridgeIOC(bridge, funcName, args){
        if(!happtype.TypeJS.isObject(bridge)){
            console.log("桥不存在");
            return ;
        }
        if(!happtype.TypeJS.isString(funcName)){
            console.log("函数名不正确");
            return ;
        }
        if(happtype.TypeJS.isFunction(bridge[funcName])){
            try{
                bridge[funcName](args);
            }catch(e){
                console.log(e.message);
                console.log(funcName);
            }
        }else{
            console.log("桥的函数不存在");
            return ;
        }
    }

    var log = {
        debug:function(logMsg){},
        warn:function(logMsg){},
        error:function(logMsg){}
    }


	/**
	 * AMD异步模块加载Asynchronous Module Definition
	 */
	return {
	    version:app.version,
		bridgeIOC:bridgeIOC,                        //从外面调用的入口
		log:log
	};
});
