define(["happtype","happprototype"] ,function(happtype){
	/**
	 * 生成随机数
	 * @param start
	 * @param len
	 * @returns
	 */
	function randomString(start,len){
		start = start || "happ";
		len = len || 32;
	　　 var $chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678';    /****默认去掉了容易混淆的字符oOLl,9gq,Vv,Uu,I1****/
	　　 var maxPos = $chars.length;
	　　 var pwd = start;
	　　 for (i = 0; i < len; i++) {
	　　　　 pwd += $chars.charAt(Math.floor(Math.random() * maxPos));
	　　 }
	　　 return pwd;
	}
	/**
	 * only for happ,other must check the unique,
	 * @param start
	 * @param len
	 * @returns
	 */
	function randomUniqueString(start,len){
		var uniqueStr = randomString(start,len);
		if(!app){
		    console.log("app.js还未加载，randomUniqueString函数内部出现依赖不存在异常");
		    return undefined;
		}
		if(app[uniqueStr]){
			return randomUniqueString();
		}
		return uniqueStr;
	}
	function generateJsCallbackStr(jsCallback){
        var jsCallbackStr = jsCallback;
        if(happtype.TypeJS.isFunction(jsCallback)){
            var happString = randomUniqueString();
            app[happString] = jsCallback;
            jsCallbackStr = "app."+happString;
        }else if(happtype.TypeJS.isString(jsCallback)){
            jsCallbackStr = jsCallback.startWith("app.")?jsCallback:("app."+jsCallback);
        }
        return jsCallbackStr;
	}
	return {
	    version:app.version,//版本
		randomString:randomString,					//生成随机字符串
		randomUniqueString:randomUniqueString,		//app唯一随机字符传验证
		TypeJS:happtype.TypeJS,					//功能类型判断
		generateJsCallbackStr:generateJsCallbackStr, //生成app对象的属性
	};
});