define(["jquery","ui-api","app"] ,function($,mobile){
	/**
	 *  表单数据转换为JSON
	 *  Example:
	 *  	form id : userForm
	 *  	var jsonData = android.serializeJson($('#userForm'));
	 */
	$.serializeJson = function(othis) {
		var o = {};
		var valueArray = $(othis).serializeArray();
		$.each(valueArray, function() {
			if (o[this.name]) {
				if (!o[this.name].push)
					o[this.name] = [ o[this.name] ];
				o[this.name].push(this.value || '');
			} else
				o[this.name] = this.value || '';
		});
		trimJson(o);
		return o;
	};
	/**
	 * trim
	 * @param objJson
	 * @returns
	 */
	$.trimJson = function(objJson) {
		$.each(objJson, function(key, value) {
			if (!$.isArray(value)) {
				objJson[key] = $.trim(value);
			}
		});
	}

    $.happClick = function(e){
        if(!e.target){
            return;
        }
        var params = {
            project:'',
            url:app.location.href,
            dataType:app.recordActionType.PAGE_CLICK,
            pageMessage:e.target.textContent
        }
        mobile.bridgeIOC(getJsCallJava(),"recordFrontInfo",JSON.stringify(params));
    }

	/**
     * 修改jquery的click
     */
    (function($){
        //同样先备份下jquery对象的click方法
        var _click = $.fn.click;
        $.fn.extend({
            click:function(func){
                var happClick = function(e){
                    //其他操作和处理
                    if(TypeUtils().isFunction($.happClick)){
                        $.happClick.apply(this,[e]);//$.happClick在android、ios、web对应的技术中实现。
                    }
                    if(func){
                        func.apply(this,[e]);
                    }
                };
                //此处用apply方法调用原来的click方法，因为click方法属于对象，所以不可直接对象._click（...）
                return _click.apply(this,[happClick]);
            }
        });
    })($);

    return $;
});