"use strict";
define(['happ-mobile',"happjs"] ,function(mobile,happjs){
    window.happajax = function(params){
        if(!params.url){
            params.error("url is undefined");
            return;
        }

        params.cache = params.cache || false;
        params.timeout = params.timeout || 15*1000;

        if(!params.method){
            params.method = "get";
        }

        if(!params.dataType){
            params.dataType = "json";
        }

        if(!params.requestType){
            params.requestType = happ.agent == "HappAndroid"||happ.agent == "HappIos"?"native":"js";
        }

        if(params.requestType == "native"){
            if(happjs.TypeJS.isFunction(params.success)){
                var happString = happjs.randomUniqueString();
                app[happString] = params.success;
                params.success = "app."+happString;
            }
            if(happjs.TypeJS.isFunction(params.error)){
                var happString = happjs.randomUniqueString();
                app[happString] = params.error;
                params.error = "app."+happString;
            }
            mobile.bridgeIOC(getRequestApi(),'doRequest',JSON.stringify(params));
            return;
        }

        require(["axios"],function(axios){
            axios({
                headers:params.headers,
                url:params.url,
                method:params.method,
                timeout:params.timeout,
                params:params.data
            }
            ).then(function(response){
                params.success(response.data);
            })
            .catch(function(err){
                params.error(err);
            });
        });
    }

    var getRequestApi = function(){
        try {
           return RequestApp;
        }catch(err){
        //ios return 一个未定义的 变量会报错，停止执行
           return "RequestApp";
        }
    }
});


