"use strict";
define(["happ-mobile","happjs"] ,function(mobile,happjs){
    var speechInit = function(){
        mobile.initASRConfig = initASRConfig;
        mobile.asrVoiceToText = asrVoiceToText;
        mobile.aliStartRecord = aliStartRecord;
        mobile.aliStopRecord = aliStopRecord;
        mobile.speechVersion = app.version;//版本
        return mobile;
    }
    /**
	 * 利用阿里语音开始录音
	 */
	function aliStartRecord(jsCallback){
		var jsCallbackStr = jsCallback;
		if(happjs.TypeJS.isFunction(jsCallback)){
			var happString = happjs.randomUniqueString();
			app[happString] = jsCallback;
			jsCallbackStr = "app."+happString;
		}
		mobile.bridgeIOC(getSpeechApi(),'aliStartRecord',jsCallbackStr);
	}
    /**
	 * 利用阿里语音结束录音
	 */
	function aliStopRecord(jsCallback){
		var jsCallbackStr = jsCallback;
		if(happjs.TypeJS.isFunction(jsCallback)){
			var happString = happjs.randomUniqueString();
			app[happString] = jsCallback;
			jsCallbackStr = "app."+happString;
		}
		mobile.bridgeIOC(getSpeechApi(),'aliStopRecord',jsCallbackStr);
	}
    /**
	 * 初始化语音识别配置
	 */
	function initASRConfig(jsonParams,jsCallback){
		var stringParams = '';
		if(!jsonParams){
			return false;
		}
		if(!jsonParams.sysType){
			return false;
		}
		stringParams = JSON.stringify(jsonParams);
		var jsCallbackStr = jsCallback;
		if(happjs.TypeJS.isFunction(jsCallback)){
			var happString = happjs.randomUniqueString();
			app[happString] = jsCallback;
			jsCallbackStr = "app."+happString;
		}
		var params = {
            'param':stringParams,
            'jsCallback':jsCallbackStr
		};
		mobile.bridgeIOC(getSpeechApi(),'initASRConfig',JSON.stringify(params));
	}
	/**
	 * 语音识别
	 */
	function asrVoiceToText(path,networkType,jsCallback){
		var jsCallbackStr = jsCallback;
		if(happjs.TypeJS.isFunction(jsCallback)){
			var happString = happjs.randomUniqueString();
			app[happString] = jsCallback;
			jsCallbackStr = "app."+happString;
		}
		var params = {
		    'path':path,
		    'networkType':networkType,
		    'jsCallback':jsCallbackStr
		};
		mobile.bridgeIOC(getSpeechApi(),'asrVoiceToText',JSON.stringify(params));
	}
    /**
     * 显示语音键盘 针对语音容器使用
     */
    function showPhoneticKeyboard(){
        mobile.bridgeIOC(getSpeechApi(),'showPhoneticKeyboard');
    }
    /**
     * 隐藏语音键盘 针对语音容器使用
     */
    function hidePhoneticKeyboard(){
        mobile.bridgeIOC(getSpeechApi(),'hidePhoneticKeyboard');
    }
    var getSpeechApi = function(){
        return window.SpeechApp?window.SpeechApp:"SpeechApp";
//        try {
//           return SpeechApp;
//        }catch(err){
//        //ios return 一个未定义的 变量会报错，停止执行
//           return "SpeechApp";
//        }
    }
    return speechInit();
});
